/*
 * AppTaskCan.c
 *
 *  Created on: 202228
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskCan.h"
static void CanDataAsk(QueueDataTrans_Type AskData);
uint8 DataPackCounter[21] = {1,1,7,5,16,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
void CanTask()
{
	CanRecvQueueHandle = xQueueCreate(5, sizeof(Can_Msg_Type)); // CANȡϢд
	Uart2ToCanDataHandle = xQueueCreate(2, sizeof(QueueDataTrans_Type)); // CANݲѯд
	CanToUart2DataHandle = xQueueCreate(1, sizeof(QueueDataTrans_Type)); // CANݻظд
	uint8 CanState = 0;
	CanIf_bRxFlag = false;
	Can_Msg_Type CanRxMsg;
	QueueDataTrans_Type CanAskData={0,NULL};
	while (TRUE)
	{
		switch (CanState)
		{
		case 0:
		{
			CanState = 1;
			break;
		}
		case 1:
		{
			memset(&CanRxMsg, 0, sizeof(CanRxMsg));
			Can_MainFunction_Read();
			BaseType_t ret = xQueueReceive(CanRecvQueueHandle, &CanRxMsg, 10);
			if (ret == pdPASS)
			{
				BleCanTransmit(CanRxMsg.id, CanRxMsg.sdu);
			}
			BaseType_t ret2 = xQueueReceive(Uart2ToCanDataHandle,&CanAskData,0);//У
			if (ret2 == pdPASS)
			{
				CanDataAsk(CanAskData);
			}
			break;
		}
		}
	}
}
static void CanDataAsk(QueueDataTrans_Type AskData)
{
	Can_Msg_Type CanTxMsg;
	uint16 CrcGet = 0x00;
	uint16 CrcCal = 0xff;
	CrcGet = (*(AskData.DataPtr + AskData.RealLen - 2)<<0 )| (*(AskData.DataPtr + AskData.RealLen - 1)<<8 );
	CrcCal = CRC16_Modbus(AskData.DataPtr,AskData.RealLen-2);
	if(CrcGet==CrcCal&&AskData.RealLen==10)
	{
		CanTxMsg.id = 0X1CEF0000;
		CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
		CanTxMsg.sdu = AskData.DataPtr;
		CanTxMsg.length = 8;
		CanIf_SendMessage(0, CanTxMsg);
	}
	if(AskData.DataPtr)
	{
		free(AskData.DataPtr);
	}
	AskData.DataPtr = NULL;
}
void BleCanTransmit(uint32 AskCanID, uint8 AskData[])
{
	Can_Msg_Type CanTxMsg;
	uint32 AnsCanID = 0;
	uint8 AnsData[8];
	memset(AnsData, 0x00, 8);
	static QueueDataTrans_Type CanAnsData={0,NULL};
	static uint8 CanDataCounter = 0;//ݴҪİ
	static uint8 DataPackDone = 0;//ѴĿ
	static uint8 CanByte0Idx = 0;
	static volatile uint8 PackState = 0;//0-δ1-ڴ2-
	uint8 CanAnsPerLen = 7;
	uint8 CanByte0Seq = 0;
	switch (AskCanID)
	{
	case 0X1CEE0000: //ͨƵݷڴ˴תuart2
	{
		if(PackState==0)
		{
			DataPackDone = 0;
			CanDataCounter = DataPackCounter[(AskData[0]>>4)];
			CanAnsData.RealLen = CanDataCounter*CanAnsPerLen + 2;
			CanAnsData.DataPtr = malloc(CanAnsData.RealLen);
			memset(CanAnsData.DataPtr,0x00,CanAnsData.RealLen);
			CanByte0Idx = (AskData[0]>>4);
			PackState = 1;
		}
		if(PackState==1)
		{
			if(CanByte0Idx==(AskData[0]>>4))
			{
				CanByte0Seq = (AskData[0])&0x0F;
				if(CanByte0Idx==4)
				{
					CanByte0Seq = CanByte0Seq + 1;
				}
				if(DataPackDone<CanDataCounter)
				{
					memcpy(CanAnsData.DataPtr+(CanByte0Seq - 1)*CanAnsPerLen,AskData,CanAnsPerLen);//CANϢֻȡǰ7
					DataPackDone++;
				}
				if(DataPackDone==CanDataCounter)
				{
					CanAnsData.RealLen = DataPackDone*CanAnsPerLen + 2;
					PackState = 2;
				}
			}
			else//Ųԣɣݳ
			{
				CanAnsData.RealLen = DataPackDone*CanAnsPerLen + 2;
				PackState = 2;
			}
		}
		if(PackState==2)
		{
			uint16 CrcCal = 0;
			CrcCal = CRC16_Modbus(CanAnsData.DataPtr,CanAnsData.RealLen-2);
			*(CanAnsData.DataPtr + CanAnsData.RealLen-2) = CrcCal &0xFF;
			*(CanAnsData.DataPtr + CanAnsData.RealLen-1) = (CrcCal>>8) &0xFF;
			if(xQueueSend(CanToUart2DataHandle,&CanAnsData,1000*10)!=pdPASS)
			{
				if(CanAnsData.DataPtr)
				{
					free(CanAnsData.DataPtr);
				}
				CanAnsData.DataPtr = NULL;
				CanAnsData.RealLen = 0;
			}
			PackState = 0;
		}
		return;
	}
	case 0X1CEE0001: //ѯ
	{
		if (AskData[0] == 1) //汾ѯ
		{
			AnsData[0] = 0x01;
			AnsData[1] = (BleVersion >> 24) & 0xFF;
			AnsData[2] = (BleVersion >> 16) & 0xFF;
			AnsData[3] = (BleVersion >> 8) & 0xFF;
			AnsData[4] = (BleVersion >> 0) & 0xFF;
		}
		else if (AskData[0] == 2) // Macַѯ
		{
			AnsData[0] = 0x02;
			AnsData[1] = (BleMacAddr[0]) & 0xFF;
			AnsData[2] = (BleMacAddr[1]) & 0xFF;
			AnsData[3] = (BleMacAddr[2]) & 0xFF;
			AnsData[4] = (BleMacAddr[3]) & 0xFF;
			AnsData[5] = (BleMacAddr[4]) & 0xFF;
			AnsData[6] = (BleMacAddr[5]) & 0xFF;
		}
		AnsCanID = 0X1CEF0001;
		break;
	}
	case 0X1CEE0002: //ӿ
	{
		if (AskData[0] == 1) //״̬ѯ
		{
			AnsData[0] = 0x01;
			AnsData[1] = (BleDisconnectFlg<<1)|(BleConnectFlg);
		}
		else if (AskData[0] == 2) //ָMacַ
		{
			BleTargetMacAddr[0] = AskData[1];
			BleTargetMacAddr[1] = AskData[2];
			BleTargetMacAddr[2] = AskData[3];
			BleTargetMacAddr[3] = AskData[4];
			BleTargetMacAddr[4] = AskData[5];
			BleTargetMacAddr[5] = AskData[6];
			BleConnectEnable = 1;
			AnsData[0] = 2;
			AnsData[1] = 2;
		}
		else if (AskData[0] == 3) //Ͽ
		{
			BleDisconnectEnable = 1;
			AnsData[0] = 3;
			AnsData[1] = 3;
		}
		AnsCanID = 0X1CEF0002;
		break;
	}
	case 0X1CEE0003: //ɫ
	{
		if (AskData[0] == 1) //ǰɫѯ
		{
			AnsData[0] = 0x01;
			AnsData[1] = BleCurrentRole;
		}
		else if (AskData[0] == 2) //ɫ
		{
			BleSetRoleEnable = 1;
			BleSetRole = AskData[1] & 0x03;
			AnsData[0] = 0x02;
			AnsData[1] = BleSetRole;
		}
		AnsCanID = 0X1CEF0003;
		break;
	}
	case 0X1CEE0004: //ػ
	{
		if (AskData[0] == 1)
		{
			if (AskData[1] == 0) //
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 0;
			}
			else if (AskData[1] == 1) //ػ
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 1;
			}
			else if (AskData[1] == 2) //
			{
				BlePwrControlEnable = 1;
				BlePwrControlFlg = 2;
			}
			AnsData[0] = 1;
			AnsData[1] = AskData[1];
		}
		AnsCanID = 0X1CEF0004;
		break;
	}
	default:
		return;
		break;
	}
	CanTxMsg.id = AnsCanID;
	CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
	CanTxMsg.sdu = AnsData;
	CanTxMsg.length = 8;
	CanIf_SendMessage(0, CanTxMsg);
	return;
}
